/*
        
        File:			DriveController.h
        Program:		KisMAC Driver Tool
	Author:			Michael Roberg
				mick@binaervarianz.de
	Description:		KisMAC is a wireless stumbler for MacOS X.
                
        This file is part of KisMAC.

    KisMAC is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    KisMAC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with KisMAC; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#import "DriveController.h"
#import "BLAuthentication.h"

@implementation DriveController

- (IBAction)apply:(id)sender
{
    [aButton setEnabled:NO];

    switch ([aDriver indexOfSelectedItem]) {
    case 0:
        switch([aChoice indexOfSelectedItem]) {
        case 0:
            [[BLAuthentication sharedInstance] executeCommand:@"/sbin/kextload" withArgs:[NSArray arrayWithObject:@"/Applications/KisMAC.app/Contents/Resources/WLanDriver.kext"]];
            break;
        case 1:
            [[BLAuthentication sharedInstance] executeCommand:@"/sbin/kextunload" withArgs:[NSArray arrayWithObjects:@"-b",@"org.theta44.iokit.WLanDriver",nil]];
            break;
        case 2:
            [[BLAuthentication sharedInstance] executeCommand:@"/sbin/kextunload" withArgs:[NSArray arrayWithObjects:@"-b",@"org.theta44.iokit.WLanDriver",nil]];
            [NSThread sleepUntilDate:[NSDate dateWithTimeIntervalSinceNow:3]];
            [[BLAuthentication sharedInstance] executeCommand:@"/sbin/kextload" withArgs:[NSArray arrayWithObject:@"/Applications/KisMAC.app/Contents/Resources/WLanDriver.kext"]];
            break;
        }
        break;
    case 1:
        switch([aChoice indexOfSelectedItem]) {
        case 0:
            [[BLAuthentication sharedInstance] executeCommand:@"/sbin/kextload" withArgs:[NSArray arrayWithObject:@"/Applications/KisMAC.app/Contents/Resources/MACJack.kext"]];
            break;
        case 1:
            [[BLAuthentication sharedInstance] executeCommand:@"/sbin/kextunload" withArgs:[NSArray arrayWithObjects:@"-b",@"org.binaervarianz.iokit.MACJack",nil]];
            break;
        case 2:
            [[BLAuthentication sharedInstance] executeCommand:@"/sbin/kextunload" withArgs:[NSArray arrayWithObjects:@"-b",@"org.binaervarianz.iokit.MACJack",nil]];
            [NSThread sleepUntilDate:[NSDate dateWithTimeIntervalSinceNow:3]];
            [[BLAuthentication sharedInstance] executeCommand:@"/sbin/kextload" withArgs:[NSArray arrayWithObject:@"/Applications/KisMAC.app/Contents/Resources/MACJack.kext"]];
            break;
        }
        break;
    case 2:
        switch([aChoice indexOfSelectedItem]) {
        case 0:
            [[BLAuthentication sharedInstance] executeCommand:@"/sbin/kextload" withArgs:[NSArray arrayWithObject:@"/Applications/KisMAC.app/Contents/Resources/AiroJack.kext"]];
            break;
        case 1:
            [[BLAuthentication sharedInstance] executeCommand:@"/sbin/kextunload" withArgs:[NSArray arrayWithObjects:@"-b",@"org.binaervarianz.iokit.AiroJack",nil]];
            break;
        case 2:
            [[BLAuthentication sharedInstance] executeCommand:@"/sbin/kextunload" withArgs:[NSArray arrayWithObjects:@"-b",@"org.binaervarianz.iokit.AiroJack",nil]];
            [NSThread sleepUntilDate:[NSDate dateWithTimeIntervalSinceNow:3]];
            [[BLAuthentication sharedInstance] executeCommand:@"/sbin/kextload" withArgs:[NSArray arrayWithObject:@"/Applications/KisMAC.app/Contents/Resources/AiroJack.kext"]];
            break;
        }
        break;
    }    
    
    [aButton setEnabled:YES];
}

@end
